=== debian/watch ===
version=4
opts=\
repack,\
compression=xz,\
repacksuffix=+dfsg,\
dversionmangle=s/\.dfsg\./-/;s/[\.\+]dfsg$//,\
filenamemangle=s/.*\/archive\/(\d\S+)\/belle-sip.*\.tar\.gz/belle-sip-$1\.tar\.gz/g \
  https://gitlab.linphone.org/BC/public/belle-sip/tags?sort=updated_desc .*/archive/([\d\.]+)/.*\.tar\.gz.*
