=== debian/changelog ===
belle-sip (5.3.105+dfsg-4) unstable; urgency=medium

  * Team upload
  * Add Breaks+Replaces on bellesip-data for sdp_grammar (Closes: #1100548)
  * bellesip-data Breaks libbellesip2t64

 -- Bastian Germann <bage@debian.org>  Mon, 17 Mar 2025 17:01:30 +0100

belle-sip (5.3.105+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Remove unneeded Breaks and Replaces from libbellesip3 against libbellesip2.
  * List explicit pathnames in debhelper fragment files.
  * Fix the belle-sip.pc pkg-config file to refer to the correct .so filename.
  * Add a backwards compatibility symlink matching old unversioned SONAME.
  * Update copyright years.

 -- Guillem Jover <gjover@sipwise.com>  Fri, 07 Mar 2025 22:54:38 +0100

belle-sip (5.3.105+dfsg-2) unstable; urgency=medium

  * Team upload
  * Drop shlibs file (Closes: #1099108)
  * Advance linphone-stack dependencies

 -- Bastian Germann <bage@debian.org>  Fri, 28 Feb 2025 16:31:54 +0100

belle-sip (5.3.105+dfsg-1) unstable; urgency=medium

  * Team upload
  * New upstream version 5.3.105+dfsg
  * Rebase patches
  * d/rules: Rename flags
  * d/copyright: Update info from new version

 -- Bastian Germann <bage@debian.org>  Thu, 27 Feb 2025 13:12:32 +0100

belle-sip (5.2.98+dfsg-2) experimental; urgency=medium

  * Tighten linphone-stack build-dependency versions properly to 5.2.98.

 -- Dennis Filder <d.filder@web.de>  Tue, 03 Oct 2023 12:52:45 +0200

belle-sip (5.2.98+dfsg-1) experimental; urgency=medium

  * New upstream release 5.2.98.
  * libbellesip3: SOVERSION bump due to ABI break.
  * New binary package bellesip-data for arch:all data from libbellesip3.

 -- Dennis Filder <d.filder@web.de>  Sun, 03 Sep 2023 05:58:44 +0200
