=== debian/control ===
Source: belle-sip
Section: libs
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Kilian Krause <kilian@debian.org>,
           Tzafrir Cohen <tzafrir@debian.org>,
           Bernhard Schmidt <berni@debian.org>,
Build-Depends: cmake,
               debhelper-compat (= 13),
               libantlr3c-dev,
               libavahi-compat-libdnssd-dev,
               libbctoolbox-dev (>= 5.3),
               libbelr-dev (>= 5.3),
               zlib1g-dev | libz-dev,
# Uncomment for regenerating the lexer/parser code
#               antlr3,
#               faketime,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://www.linphone.org
Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/belle-sip.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/belle-sip
Description: SIP stack from the Linphone team

Package: libbellesip-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libbctoolbox-dev (>= 5.3),
         libbellesip3 (= ${binary:Version}),
         libbelr-dev (>= 5.3),
         ${misc:Depends},
Description: SIP stack from the Linphone team (development files)
 Belle-Sip is a new SIP stack (RFC3261) developed by the Linphone team.
 .
 Belle-Sip supports multiple transports at the same time, has a dual
 IPv6 and IPv4 stack, is fully asynchronous and implements the
 +sip.instance and alias parameters. It also handles network
 disconnections better, offers a privacy API and supports rich presence.
 .
 SIP/TLS is handled by mbed TLS (by way of bctoolbox), not OpenSSL.
 .
 This package contains the development files.

Package: libbellesip3
Pre-Depends: ${misc:Pre-Depends},
Architecture: any
Multi-Arch: same
Recommends: dns-root-data
Depends: ${misc:Depends},
         ${shlibs:Depends},
# The grammar file src/sdp/sdp_grammar is apparently used by
# liblinphone to create a parser at run-time.  Does this make it part
# of some ABI?  Newer code might work with an older grammar, but not
# necessarily vice versa.  I cannot tell.  But if we consider it part
# of the ABI and put it into libbellesipN we'd have to use a
# soname-dependent path for /all/ grammar files and patch that in at
# god-knows-how-many places.  Instead we assume it is not part of the
# ABI, put it into a -data package and adjust the version here
# manually if src/sdp/sdp_grammar changes.  The other packages should
# be changed to do the same.  This should prevent breakage while
# potentially preserving some co-installability.
         bellesip-data (>= 5.3),
Description: SIP stack from the Linphone team
 Belle-Sip is a new SIP stack (RFC3261) developed by the Linphone team.
 .
 Belle-Sip supports multiple transports at the same time, has a dual
 IPv6 and IPv4 stack, is fully asynchronous and implements the
 +sip.instance and alias parameters. It also handles network
 disconnections better, offers a privacy API and supports rich presence.
 .
 SIP/TLS is handled by mbed TLS (by way of bctoolbox), not OpenSSL.

Package: bellesip-data
Architecture: all
Breaks: libbellesip1 (<< 5.2), libbellesip2 (<< 5.3), libbellesip2t64 (<< 5.3)
Replaces: libbellesip1 (<< 5.2), libbellesip2 (<< 5.3), libbellesip2t64 (<< 5.3)
Description: SIP stack from the Linphone team
 Belle-Sip is a new SIP stack (RFC3261) developed by the Linphone team.
 .
 Belle-Sip supports multiple transports at the same time, has a dual
 IPv6 and IPv4 stack, is fully asynchronous and implements the
 +sip.instance and alias parameters. It also handles network
 disconnections better, offers a privacy API and supports rich presence.
 .
 This package contains architecture-independent files.
